using System;
using System.Collections.Generic;
using System.Text;

namespace FrameworkX.ObjectSpace.Validation
{
    public class IsNumericAttribute : ValidationAttribute
    {
        public override ValidationResult Validate(string propertyName, string value)
        {
            double num1;            
            if (!double.TryParse (value, out num1))
            {
                return new ValidationResult(false,
                    string.Format("{0} must be a numeric value.",
                    Util.GetSpacedStringFromWordCapitalizedString(propertyName)));
            }
            else
            {
                return new ValidationResult(true);
            }            
        }
    }
}
