using System;
using System.Collections.Generic;
using System.Text;

namespace FrameworkX.ObjectSpace.Validation
{
    public class ValidationResult
    {
        private bool _isSuccessful = false;
        private string _message = string.Empty;

        public ValidationResult()
        {
        }

        public ValidationResult(bool isSuccessful, string message)
        {
            this._isSuccessful = isSuccessful;
            this._message = message;
        }

        public ValidationResult(bool isSuccessful)
        {
            this._isSuccessful = isSuccessful;
        }

        public ValidationResult(string message)
        {
            this._message = message;
        }

        public bool IsSuccessful
        {
            get { return _isSuccessful; }
        }

        public string Message
        {
            get { return _message; }
        }

        internal void SetMessage(string message)
        {
            this._message = message;
        }

        internal void SetSuccess(bool isSuccessful)
        {
            this._isSuccessful = isSuccessful;
        }
    }
}
