/*
 *	2004 JAN 24 SHP
 *		1. Class created
 */

using System;

using FrameworkQ.ObjectSpace.Data.Schema;

namespace FrameworkQ.ObjectSpace.Data.Schema
{
	/// <summary>
	/// If you want your own object populator then use this attribute. Enter
	/// a type that implements IPopulateObject interface. That class will be 
	/// used when populating objects.
	/// </summary>
	[AttributeUsage(AttributeTargets.Class)]
	public class CustomObjectPopulatorAttribute : System.Attribute 
	{
		private Type _populatorType = null;

		/// <summary>
		/// CustomObjectPopulatorAttribute constructor
		/// </summary>
		/// <param name="populator">The type of populator obeject. The type 
		/// must implement IPopulator interface.</param>
		public CustomObjectPopulatorAttribute(Type populator)
		{
			_populatorType = populator;
		}

		/// <summary>
		/// Gets the type of populator
		/// </summary>
		public Type PopulatorType
		{
			get{return _populatorType;}
		}

	}
}
