using System;
using System.Collections.Generic;
using System.Text;

namespace FrameworkQ.ObjectSpace.Data.Schema
{
    public class EncryptedStringPropertyAttribute: Attribute
    {

        public EncryptedStringPropertyAttribute(string encryptionKey, bool loadEncryptionKeyFromConfig)
        {
            _encryptionKey = encryptionKey;
            _loadEncryptionKeyFromConfig = loadEncryptionKeyFromConfig;
        }

        private string _encryptionKey = string.Empty;
        public string EncryptionKey
        {
            get { return _encryptionKey; }
        }

        private bool _loadEncryptionKeyFromConfig = false;
        public bool LoadEncryptionKeyFromConfig
        {
            get { return _loadEncryptionKeyFromConfig; }
        }
    }
}
