using System;

namespace FrameworkQ.ObjectSpace.Data.Schema
{
	/// <summary>
	/// Marks a field as primary
	/// </summary>
	public class PrimaryKeyAttribute : ConstraintAttribute
	{
		public PrimaryKeyAttribute() : base ( ConstraintHelper.GeneratePrimaryKey )
		{
		}

        public PrimaryKeyAttribute(params string[] fields)
            : base(ConstraintHelper.GeneratePrimaryKey)
        {
            _fields = fields;
        }

        private string[] _fields;
        public string[] Fields 
        {
            get { return _fields;}
        }

	}
}
