using System;

namespace FrameworkQ.ObjectSpace.Data.Schema
{
	/// <summary>
	/// Helps to mark a property not bound to database.
	/// For example: We dont want the email to be stored in the 
	/// same table. So we say on Email property this
	/// <code>
	///		[PropertyBound(false)]
	///		public string Email
	/// </code>
	/// </summary>
	[AttributeUsage( AttributeTargets.Property )]
	public class PropertyBoundAttribute : System.Attribute
	{
	    private bool  _IsBound = false;
 
		public PropertyBoundAttribute( bool bound )
		{
			_IsBound = bound;
		}
		public bool IsBound
		{
			get
			{
				return _IsBound;
			}
		}
	}
}
