using System;

namespace FrameworkQ.ObjectSpace.Data.SqlObjects
{
	/// <summary>
	/// Encapsulates SQL CASE clause
	/// </summary>
	public class CaseClause
	{
		CaseItemCollection items = new CaseItemCollection();
		SqlExpression elseVal = null;
		
		/// <summary>
		/// Creates a new CaseClause
		/// </summary>
		public CaseClause()
		{
		}

		/// <summary>
		/// Gets the <see cref="CaseTerm"/> collection for this CaseClause
		/// </summary>
		public CaseItemCollection Items
		{
			get { return this.items; }
		}

		/// <summary>
		/// Gets or sets the value CASE default value
		/// </summary>
		public SqlExpression ElseValue
		{
			get { return this.elseVal; }
			set { this.elseVal = value; }
		}
	}
}
