using System;

namespace FrameworkQ.ObjectSpace.Data.SqlObjects
{
	/// <summary>
	/// Encapsulates a single WHEN ... THEN ... statement
	/// </summary>
	public class CaseItem
	{
		WhereClause cond;
		SqlExpression val;

		/// <summary>
		/// Creates a new CaseTerm
		/// </summary>
		/// <param name="condition">Condition for the WHEN clause</param>
		/// <param name="val">Value for the THEN clause</param>
		public CaseItem(WhereClause condition, SqlExpression val)
		{
			this.cond = condition;
			this.val = val;
		}

		internal WhereClause Condition
		{
			get { return this.cond; }
		}

		internal SqlExpression Value
		{
			get { return this.val; }
		}
	}
}
