﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using FrameworkX.CommandLine;

namespace FrameworkX.HadithDB.Core.Testbed
{
    public abstract class DatabaseCommandBase : Command
    {
        public DatabaseCommandBase(string commandName) : base(commandName) { }

        [CommandParameter(commandParameter: "host"
            , isOptional: false
            , optionType: CommandOption.CommandOptionType.String
            , useConfigurationDefaults: true
            , additionalHelpText: "Database server address")]
        public string Host { get; set; }

        [CommandParameter(commandParameter: "user"
            , isOptional: false
            , optionType: CommandOption.CommandOptionType.String
            , useConfigurationDefaults: true
            , additionalHelpText: "Database username")]
        public string Username { get; set; }

        [CommandParameter(commandParameter: "password"
            , isOptional: false
            , optionType: CommandOption.CommandOptionType.String
            , useConfigurationDefaults: true
            , additionalHelpText: "Database password")]
        public string Password { get; set; }

        [CommandParameter(commandParameter: "database"
            , isOptional: false
            , optionType: CommandOption.CommandOptionType.String
            , useConfigurationDefaults: true
            , additionalHelpText: "Database name")]
        public string Database { get; set; }

        protected string ConnectionString
        {
            get 
            {
                return string.Format("User Id={1};Password={2};Data Source={0};Initial Catalog={3}",
                this.Host,this.Username,this.Password,this.Database);
            }
 
        }
    }
}
