﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using FrameworkX.CommandLine;
using FrameworkX.ObjectSpace;
using FrameworkX.ObjectSpace.Data.Providers;
using FrameworkX.ObjectSpace.Data.Providers.SqlServer;
using System.Data;

namespace FrameworkX.HadithDB.Core.Testbed
{
    //[FrameworkX.ObjectSpace.Util.ConcretePopulator(InstallCommand.P)]
    [Command("install", "Installs the hadith database structure")]
    class InstallCommand : DatabaseCommandBase
    {

        public static readonly FrameworkX.ObjectSpace.Util.ConcretePopulatorDelegate P;

        public static object ConcretePopulator ( IDataReader reader)
        {
            return null;
        }
        public InstallCommand() : base(commandName: "install")
        {
        }
        
        public override void Execute()
        {
            IDatabaseProvider sqlProvider = new SqlServerProvider();
            Configuration conf = new Configuration(sqlProvider, this.ConnectionString);
            Database db = new Database(conf, false);

            Type[] types = 
            {
                /*
                typeof(ReligiousInclination),
                typeof(Reputation),
                typeof(Language),
                typeof(Person),
                typeof(Narrator)
                 */
            };

            Queue<Type> installQueue = new Queue<Type>(types);

            while (installQueue.Count > 0)
            {
                db.EnsureStorage(installQueue.Dequeue());
            }
        }


    }
}
