﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using FrameworkX.CommandLine;

namespace FrameworkX.HadithDB.Core.Testbed
{
    class Program
    {
        static void Main(string[] args)
        {
            Parser parser = new Parser("Command Line Utility for Hadith Database");
            
            parser.RegisterCommand(typeof(InstallCommand));
            parser.RegisterCommand(typeof(UninstallCommand));
            
            parser.IsFirstWordCommand = true;
            parser.ConfigurationDefaults["user"] = "sa";
            parser.ConfigurationDefaults["host"] = ".\\SQL2008";
            parser.ConfigurationDefaults["password"] = "Sql123@";
            parser.ConfigurationDefaults["database"] = "HadithDB";


            parser.UseConfigurationDefaults=true;
            while (true)
            {
                Console.Write("Enter Command in the line below: \n");
                string input = Console.ReadLine();
                parser.CommandKeyword = CommandOption.Opt("action", CommandOption.CommandOptionType.String, false);
                CommandParseResult result = parser.ParseCommand(input.Split(" ".ToCharArray()));
                if (result.ErrorOccurred)
                {
                    Console.WriteLine(result.ErrorMessage);
                }
                else
                {
                    result.Command.Execute();
                }
            }            
        }

        
    }
}
