﻿using System;
using System.Collections.Generic;
using System.Text;
using FrameworkX.CommandLine;
using FrameworkX.ObjectSpace;
using FrameworkX.ObjectSpace.Data.Providers;
using FrameworkX.ObjectSpace.Data.Providers.SqlServer;

namespace FrameworkX.HadithDB.Core.Testbed
{
    [Command("uninstall", "Installs the hadith database structure")]
    class UninstallCommand : DatabaseCommandBase
    {

        public UninstallCommand()
            : base(commandName: "uninstall")
        {
        }

        public override void Execute()
        {
            IDatabaseProvider sqlProvider = new SqlServerProvider();
            Configuration conf = new Configuration(sqlProvider, this.ConnectionString);
            Database db = new Database(conf, false);

            Type[] types = 
            {
                /*
                typeof(ReligiousInclination),
                typeof(Reputation),
                typeof(Language),
                typeof(Person),
                typeof(Narrator)
                 * */
            };

            Stack<Type> installQueue = new Stack<Type>(types);

            while (installQueue.Count > 0)
            {
                db.DestroyStorage(installQueue.Pop());
            }
        }

    }
}
